<template>
  <div class="starList">
    <FilterStar @filter="getFilter" />
    <List :stars="list" />
  </div>
</template>

<script>
import List from "./list.vue";
import FilterStar from "./filter.vue";
import axios from "axios";

export default {
  layout: "template",
  name: "StarList",
  components: {
    List,
    FilterStar,
  },
  data: function () {
    return {
      list: [],
    };
  },
  methods: {
    // Modifie la source de la liste en fonction du filtre séléctionné
    getFilter(filter) {
      switch (filter) {
        case "all":
          this.list = this.$store.getters["getStars"];
          break;
        case "moon":
          this.list = this.$store.getters["getStars"].filter(
            (star) => !star.isPlanet
          );
          break;
        case "planet":
          this.list = this.$store.getters["getStars"].filter(
            (star) => star.isPlanet
          );
          break;
        default:
          this.list = this.stars;
          break;
      }
    },
  },
  mounted() {
    // Récupère les données du store
    this.list = this.$store.getters["getStars"];
    if (this.list.length < 1) {
      // Récupère les données de l'API
      axios
        .get("https://api.le-systeme-solaire.net/rest/bodies/")
        .then((reponse) => {
          this.$store.commit("add", reponse.data.bodies);
          this.list = reponse.data.bodies;
        });
    }
  },
};
</script>

<style>
.starList {
  padding-top: 16px;
  padding-bottom: 16px;
  background-color: #3a256e;
  color: #fff;
}
</style>